%define pkg    http-parser
%define ver    2.6.0
%define maj    %(echo %{ver} | cut -d'.' -f1)


Summary:       A HTTP request/response parser for C
Name:          %{pkg}
Version:       %{ver}
Release:       1%{?dist}%{?pext}
License:       MIT
Group:         System Environment/Libraries
Source0:       http://github.com/joyent/%{name}/archive/%{name}-v%{version}.tar.gz
Patch0:        %{name}-2.5.0-build.patch
URL:           http://github.com/joyent/%{name}/
Buildroot:     %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Vendor:        Joyent, Inc.

%description
This is a parser for HTTP messages written in C. It parses both requests and
responses. The parser is designed to be used in performant HTTP applications.
It does not make any syscalls nor allocations, it does not buffer data, and
can be interrupted at anytime. Depending on the architecture, it only needs
about 40 bytes of data per message stream (per connection in a web server).


%package       devel
Summary:       Development tools for %{name}
Group:         Development/Libraries
Requires:      %{name} = %{version}-%{release}

%description   devel
The %{name}-devel package contains the libraries and header files for
developing software using %{name}.


%package       static
Summary:       Static libraries for %{name}
Group:         Development/Libraries
Requires:      %{name}-devel = %{version}-%{release}

%description   static
The %{name}-static package contains the statically linkable libraries
for %{name}.


%prep
%setup -q
%patch0 -p1


%build
export CC="%{__cc}"
export CFLAGS_EXTRA="${RPM_OPT_FLAGS}"

# Build strict library
%{__make} \
	SONAME="libhttp_parser_strict.so.%{maj}" \
	%{?_smp_mflags}                          \
	package_g library_g test_g

# Build fast library
%{__make} \
	SONAME="libhttp_parser.so.%{maj}"        \
	%{?_smp_mflags}                          \
	package library test_fast


%check
%{__make} test


%install
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_includedir}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_libdir}

%{__install} -m 0644 http_parser.h     ${RPM_BUILD_ROOT}%{_includedir}

for LIB in libhttp_parser_strict.so libhttp_parser.so; do
  %{__install} -m 0755 ${LIB}.%{maj}   ${RPM_BUILD_ROOT}%{_libdir}/${LIB}.%{ver}
  %{__ln_s}    -f      ${LIB}.%{ver}   ${RPM_BUILD_ROOT}%{_libdir}/${LIB}
done

%{__install} -m 0644 libhttp_parser*.a ${RPM_BUILD_ROOT}%{_libdir}


%post -p /sbin/ldconfig


%postun -p /sbin/ldconfig


%clean
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc AUTHORS LICENSE* README*
%{_libdir}/libhttp_parser.so.*
%{_libdir}/libhttp_parser_strict.so.*

%files devel
%defattr(-,root,root)
%{_includedir}/http_parser.h
%{_libdir}/libhttp_parser.so
%{_libdir}/libhttp_parser_strict.so

%files static
%defattr(-,root,root)
%{_libdir}/libhttp_parser.a
%{_libdir}/libhttp_parser_strict.a


%changelog
* Mon Nov 16 2015 Peter Pramberger <peterpramb@member.fsf.org> - 2.6.0-1
- New version (2.6.0)

* Sat Jul 18 2015 Peter Pramberger <peterpramb@member.fsf.org> - 2.5.0-1
- New version (2.5.0)

* Mon Mar 17 2014 Peter Pramberger <peterpramb@member.fsf.org> - 2.3-1
- Initial build
